#ifdef WIN32
#include <windows.h>
#endif

#include <gl\gl.h>
#include <gl\glu.h>

#include "skeletonElements.h"
#include "skeleton.h"
#include "globalSpace.h"

Skeleton* moveSkelet[8];
/***********************************DIRECT KINEMATICS ANIMATION****************************/
void AnimateSkeletDK(GLint timer, Skeleton* skeletDK){

  //moves skelet with direct kinematics
  skeletDK = moveSkelet[timer/1000];
  glPushMatrix();
  switch(side){
    case 1:
      moveForward += move;
      rotate = 0;
      if(moveForward > 10.0){side = 2;}
      glTranslatef(moveSideways, 0.0, moveForward);
      break;
    case 2:
      moveSideways += move;
      rotate = 90;
      if(moveSideways > 10.0){side = 3;}
      glTranslatef(moveSideways, 0.0, moveForward);
      break;
    case 3:
      moveForward -= move;
      rotate = 180;
      if(moveForward < -10.0){side = 4;}
      glTranslatef(moveSideways, 0.0, moveForward);
      break;
    case 4:
      moveSideways -= move;
      rotate = 270;
      if(moveSideways < -10.0){side = 1;}
      glTranslatef(moveSideways, 0.0, moveForward);
      break;
  }
  glRotatef(rotate, 0.0, 1.0, 0.0);
  skeletDK->DrawSkeleton();
  glPopMatrix();
}

void setMoveSkelet(){

  //defines figures that change during moving the skeletDK
  {
    //first move
    moveSkelet[0] = new Skeleton(bodyC[1]);
  }

  {
    //second move
    moveSkelet[1] = new Skeleton(bodyC[1]);
    moveSkelet[1]->rhipRotUD->rotation = 67.5;
    moveSkelet[1]->rkneeRotUD->rotation = 17.5;
    moveSkelet[1]->lhipRotUD->rotation = 107.5;
    moveSkelet[1]->lkneeRotUD->rotation = 0.0;
    moveSkelet[1]->rshoulderRotUD->rotation = 112.5;
    moveSkelet[1]->relbowRotUD->rotation = -17.5;
    moveSkelet[1]->lshoulderRotUD->rotation = 72.5;
    moveSkelet[1]->lelbowRotUD->rotation = 0.0;
  }

  {
    //third move
    moveSkelet[2] = new Skeleton(bodyC[1]);
    moveSkelet[2]->rhipRotUD->rotation = 67.5;
    moveSkelet[2]->rkneeRotUD->rotation = 0.0;
    moveSkelet[2]->lhipRotUD->rotation = 107.5;
    moveSkelet[2]->lkneeRotUD->rotation = 15.0;
    moveSkelet[2]->rshoulderRotUD->rotation = 112.5;
    moveSkelet[2]->relbowRotUD->rotation = 0.0;
    moveSkelet[2]->lshoulderRotUD->rotation = 72.5;
    moveSkelet[2]->lelbowRotUD->rotation = -15.0;
  }

  {
    //fourth move
    moveSkelet[3] = new Skeleton(bodyC[1]);
    moveSkelet[3]->rhipRotUD->rotation = 90.0;
    moveSkelet[3]->rkneeRotUD->rotation = 0.0;
    moveSkelet[3]->lhipRotUD->rotation = 90.;
    moveSkelet[3]->lkneeRotUD->rotation = 0.0;
    moveSkelet[3]->rshoulderRotUD->rotation = 90.0;
    moveSkelet[3]->relbowRotUD->rotation = 0.0;
    moveSkelet[3]->lshoulderRotUD->rotation = 90.0;
    moveSkelet[3]->lelbowRotUD->rotation = 0.0;
  }

  {
    //fifth move
    moveSkelet[4] = new Skeleton(bodyC[1]);
    moveSkelet[4]->rhipRotUD->rotation = 107.5;
    moveSkelet[4]->rkneeRotUD->rotation = 0.0;
    moveSkelet[4]->lhipRotUD->rotation = 67.5;
    moveSkelet[4]->lkneeRotUD->rotation = 17.5;
    moveSkelet[4]->rshoulderRotUD->rotation = 72.5;
    moveSkelet[4]->relbowRotUD->rotation = 0.0;
    moveSkelet[4]->lshoulderRotUD->rotation = 112.5;
    moveSkelet[4]->lelbowRotUD->rotation = -17.5;
  }

  {
    //sixth move
    moveSkelet[5] = new Skeleton(bodyC[1]);
    moveSkelet[5]->rhipRotUD->rotation = 107.5;
    moveSkelet[5]->rkneeRotUD->rotation = 15.0;
    moveSkelet[5]->lhipRotUD->rotation = 67.5;
    moveSkelet[5]->lkneeRotUD->rotation = 0.0;
    moveSkelet[5]->rshoulderRotUD->rotation = 72.5;
    moveSkelet[5]->relbowRotUD->rotation = -15.0;
    moveSkelet[5]->lshoulderRotUD->rotation = 112.5;
    moveSkelet[5]->lelbowRotUD->rotation = 0.0;
  }
}
