#ifdef WIN32
#include <windows.h>
#endif

#include <gl\gl.h>
#include <gl\glu.h>
#include "functions.h"
#include <cmath>
#include <cstdio>

using namespace std;

void DrawQuad(GLfloat width, GLfloat height, GLfloat depth){

  glBegin(GL_QUADS);

  //front quad
  glColor3f(0.0, 0.0, 0.4);
  glVertex3f(-width, 0.0f, 0.0f);
  glVertex3f(width, 0.0f, 0.0f);
  glColor3f(0.0, 0.0, 0.8);
  glVertex3f(width, height, 0.0f);
  glVertex3f(-width, height, 0.0f);

  //left quad
  glColor3f(0.0, 0.0, 0.4);
  glVertex3f(width, 0.0f, 0.0f);
  glVertex3f(width, 0.0f, -depth);
  glColor3f(0.0, 0.0, 0.8);
  glVertex3f(width, height, -depth);
  glVertex3f(width, height, 0.0f);

  //back quad
  glColor3f(0.0, 0.0, 0.4);
  glVertex3f(-width, 0.0f, -depth);
  glVertex3f(width, 0.0f, -depth);
  glColor3f(0.0, 0.0, 0.8);
  glVertex3f(width, height, -depth);
  glVertex3f(-width, height, -depth);

  //right quad
  glColor3f(0.0, 0.0, 0.4);
  glVertex3f(-width, 0.0f, -depth);
  glVertex3f(-width, 0.0f, 0.0f);
  glColor3f(0.0, 0.0, 0.8);
  glVertex3f(-width, height, 0.0f);
  glVertex3f(-width, height, -depth);

  //up quad
  glColor3f(0.0, 0.0, 0.7);
  glVertex3f(-width, height, 0.0f);
  glVertex3f(width, height, 0.0f);
  glVertex3f(width, height, -depth);
  glVertex3f(-width, height, -depth);

  glEnd();
}

GLfloat toRadian(GLfloat degrees){
  //turns degrees to radians
  return degrees *3.141592653/180;
}

GLfloat distance(GLfloat A[3], GLfloat B[3]){

  GLfloat dist;
  dist = (float)sqrt((B[0]-A[0])*(B[0]-A[0]) + (B[1]-A[1])*(B[1]-A[1]) + (B[2]-A[2])*(B[2]-A[2]));
//  printf("\nA= %f %f %f\n", A[0],A[1],A[2]);
//  printf("B= %f %f %f\n", B[0],B[1],B[2]);
//  printf("dist = %f",dist);
  return dist;
}
