/**************************MY CODE***************************/
#include <windows.h>		// Header File For Windows
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
//#include <gl\glaux.h>		// Header File For The Glaux Library
#include <cstdio>
#include <cmath>
#include <string>
#include <iostream>

#include "functions.h"
#include "jointNames.h"
#include "skeletonElements.h"
#include "skeleton.h"
#include "animateSkeleton.h"
#include "globalSpace.h"

using namespace std;

//#define PRAVCI
/********************GLOBAL VARIABLES************************/
GLfloat rotX;
GLfloat rotY;
GLfloat rotZ;
GLfloat zoom = -25.0;
GLint timer = 0;
string ime = "Zeljko Mijocevic";

//GLfloat moveForward = 0.0;
//GLfloat moveSideways = -10.0;
//GLint side = 1;
//GLint rotate = 0;
//GLfloat move = 0.005;

GLfloat moveDuration = move*1000;
GLfloat tolerance = 0.01;

Color* color[2] = {new Color(0.0, 0.0, 0.8), new Color(0.0, 0.2, 0.3)};
//color[0] = new Color(0.0, 0.0, 0.8);
//color[1] = new Color(0.0, 0.2, 0.3);
GLfloat positions[3][3]={{0,0,0}, {0,0,0}, {1.2,4.9,1.5}};
GLfloat angle;
bool DK = FALSE;
bool animateJacobian = TRUE;
//GLint count;
GLfloat k = 0.1;//convergence coefficient
/**********************************************/

/*******************SKELETONS*****************************/
Skeleton* skelet = new Skeleton(color[0]);
Skeleton* skeletDK = new Skeleton(color[1]);
//Skeleton* moveSkelet[8];
/*******************************************/

///******************************INVERSE KINEMATICS ANIMATION*******************/
void GetJointPosition(int jointNameVar, GLfloat position[3], Skeleton* skelet);
GLfloat GetMoveAngleUD(GLfloat begin[3], GLfloat top[3], GLfloat end[3]);
GLfloat GetMoveAngleLR(GLfloat begin[3], GLfloat top[3], GLfloat end[3]);
void MakeJacobian33(Skeleton* skelet);

void AnimateSkeletCCD(Skeleton* skelet){

  //animate skelet with CCD method
  if(positions[2][0]<0){
  //right arm
  //set left arm to default position
  skelet->lshoulderRotUD->SetRotation(90.0);
  skelet->lshoulderRotLR->SetRotation(0.0);
  skelet->lelbowRotUD->SetRotation(-15.0);

  GetJointPosition(jointShoulderR, positions[0], skelet);
  GetJointPosition(jointWristR, positions[1], skelet);
  angle = GetMoveAngleUD(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> tolerance){
//    count++;
//    cout<<"distance = "<<distance(positions[1], positions[2])<<endl;
//    cout<<"count = "<<count<<endl;
    skelet->rshoulderRotUD->SetRotation(skelet->rshoulderRotUD->rotation - angle);//rotation -=angle;
  }

  angle = GetMoveAngleLR(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> tolerance){
    skelet->rshoulderRotLR->SetRotation(skelet->rshoulderRotLR->rotation + angle);//rotation +=angle;
  }

  GetJointPosition(jointElbowR, positions[0], skelet);
  GetJointPosition(jointWristR, positions[1], skelet);
  angle = GetMoveAngleUD(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> 0.001){
    skelet->relbowRotUD->SetRotation(skelet->relbowRotUD->rotation - angle);//rotation -=angle;
  }
  }
  else{
  //left arm
  //set right arm to default position
  skelet->rshoulderRotUD->SetRotation(90.0);
  skelet->rshoulderRotLR->SetRotation(0.0);
  skelet->relbowRotUD->SetRotation(-15.0);

  GetJointPosition(jointShoulderL, positions[0], skelet);
  GetJointPosition(jointWristL, positions[1], skelet);
  angle = GetMoveAngleUD(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> 0.01){
//    count++;
//    cout<<"distance = "<<distance(positions[0], positions[2])<<endl;
//    cout<<"count = "<<count<<endl;
    skelet->lshoulderRotUD->SetRotation(skelet->lshoulderRotUD->rotation - angle);//rotation -=angle;
  }

  angle = GetMoveAngleLR(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> 0.001){
    skelet->lshoulderRotLR->SetRotation(skelet->lshoulderRotLR->rotation + angle);//rotation +=angle;
  }

  GetJointPosition(jointElbowL, positions[0], skelet);
  GetJointPosition(jointWristL, positions[1], skelet);
  angle = GetMoveAngleUD(positions[0], positions[1], positions[2]);
  if(distance(positions[1], positions[2])> 0.01){
    skelet->lelbowRotUD->SetRotation(skelet->lelbowRotUD->rotation - angle);//rotation -=angle;
  }
  }
}

void AnimateSkeletJakobian(Skeleton* skelet){

  GLfloat Jacobian[3][3];
  GLfloat IJacobian[3][3];

  GLfloat dx;
  GLfloat dy;
  GLfloat dz;

  GLfloat dalpha;
  GLfloat dbeta;
  GLfloat dgama;

  {//make Jacobian matrix
  GLfloat alpha;
  GLfloat beta;
  GLfloat gama;
  alpha = beta = gama = 0;
  //gets joint position by name
  if(positions[2][0]<0) GetJointPosition(jointWristR, positions[0], skelet);
  else GetJointPosition(jointWristL, positions[0], skelet);

  if(distance(positions[0], positions[2])<0.001)return;
//  cout<<"distance = "<<distance(positions[0], positions[2])<<endl;

  if(positions[2][0]<0)
  {
    alpha = toRadian(skelet->rshoulderRotUD->rotation);
    beta = toRadian(skelet->rshoulderRotLR->rotation);
    gama = toRadian(skelet->relbowRotUD->rotation);

    //set left arm to default position
    skelet->lshoulderRotUD->SetRotation(90.0);
    skelet->lshoulderRotLR->SetRotation(0.0);
    skelet->lelbowRotUD->SetRotation(-15.0);
  }
  else
  {
    alpha = toRadian(skelet->lshoulderRotUD->rotation);
    beta = toRadian(skelet->lshoulderRotLR->rotation);
    gama = toRadian(skelet->lelbowRotUD->rotation);

    //set right arm to default position
    skelet->rshoulderRotUD->SetRotation(90.0);
    skelet->rshoulderRotLR->SetRotation(0.0);
    skelet->relbowRotUD->SetRotation(-15.0);
  }

  Jacobian[0][0] = 0;
  Jacobian[0][1] = 1.5*cos(beta) + 1.5*cos(gama)*cos(beta);
  Jacobian[0][2] = -1.5*sin(gama)*sin(beta);

  Jacobian[1][0] = -1.5*(1 + cos(gama))*cos(beta)*cos(alpha) + 1.5*sin(gama)*sin(alpha);
  Jacobian[1][1] = 1.5*(1 + cos(gama))*sin(beta)*sin(alpha);
  Jacobian[1][2] = 1.5*sin(gama)*cos(beta)*sin(alpha) - 1.5*cos(gama)*cos(alpha);

  Jacobian[2][0] = -1.5*sin(alpha)*cos(beta) - 1.5*sin(gama)*cos(alpha) - 1.5*cos(gama)*sin(alpha)*cos(beta);
  Jacobian[2][1] = -1.5*cos(alpha)*sin(beta) - 1.5*cos(gama)*cos(alpha)*sin(beta);
  Jacobian[2][2] = -1.5*cos(gama)*sin(alpha) - 1.5*sin(gama)*cos(alpha)*cos(beta);

  }

  {
    //make inverse Jacobian
    GLfloat det = 1.0;

    det = (Jacobian[0][0]*(Jacobian[1][1]*Jacobian[2][2] - Jacobian[1][2]*Jacobian[2][1])
           -Jacobian[0][1]*(Jacobian[1][0]*Jacobian[2][2] - Jacobian[1][2]*Jacobian[2][0])
           +Jacobian[0][2]*(Jacobian[1][0]*Jacobian[2][1] - Jacobian[1][1]*Jacobian[2][0]));

    IJacobian[0][0] = (Jacobian[1][1]*Jacobian[2][2] - Jacobian[1][2]*Jacobian[2][1])/det;
    IJacobian[0][1] = (Jacobian[0][2]*Jacobian[2][1] - Jacobian[0][1]*Jacobian[2][2])/det;
    IJacobian[0][2] = (Jacobian[0][1]*Jacobian[1][2] - Jacobian[0][2]*Jacobian[1][1])/det;

    IJacobian[1][0] = (Jacobian[1][2]*Jacobian[2][0] - Jacobian[1][0]*Jacobian[2][2])/det;
    IJacobian[1][1] = (Jacobian[0][0]*Jacobian[2][2] - Jacobian[0][2]*Jacobian[2][0])/det;
    IJacobian[1][2] = (Jacobian[0][2]*Jacobian[1][0] - Jacobian[0][0]*Jacobian[1][2])/det;

    IJacobian[2][0] = (Jacobian[1][0]*Jacobian[2][1] - Jacobian[1][1]*Jacobian[2][0])/det;
    IJacobian[2][1] = (Jacobian[2][0]*Jacobian[0][1] - Jacobian[0][0]*Jacobian[2][1])/det;
    IJacobian[2][2] = (Jacobian[0][0]*Jacobian[1][1] - Jacobian[0][1]*Jacobian[1][0])/det;

  }

//  count++;
//  cout<<"count = "<<count<<endl;
  dx = (positions[2][0] - positions[0][0])/k;
  dy = (positions[2][1] - positions[0][1])/k;
  dz = (positions[2][2] - positions[0][2])/k;

  dalpha = (IJacobian[0][0]*dx + IJacobian[0][1]*dy + IJacobian[0][2]*dz);
  dbeta = (IJacobian[1][0]*dx + IJacobian[1][1]*dy + IJacobian[1][2]*dz);
  dgama = (IJacobian[2][0]*dx + IJacobian[2][1]*dy + IJacobian[2][2]*dz);

  if(positions[2][0]<0)
  {
    skelet->rshoulderRotUD->SetRotation(skelet->rshoulderRotUD->rotation + dalpha);
    skelet->rshoulderRotLR->SetRotation(skelet->rshoulderRotLR->rotation + dbeta);
    skelet->relbowRotUD->SetRotation(skelet->relbowRotUD->rotation + dgama);
  }
  else
  {
    skelet->lshoulderRotUD->SetRotation(skelet->lshoulderRotUD->rotation + dalpha);
    skelet->lshoulderRotLR->SetRotation(skelet->lshoulderRotLR->rotation + dbeta);
    skelet->lelbowRotUD->SetRotation(skelet->lelbowRotUD->rotation + dgama);
  }
}

///****************************************/
//
///*******************FREE MEMORY********************/
void DeleteSkeletons(){

  delete[] moveSkelet;
  delete skelet;
  delete skeletDK;
}

/****************************************/

/***************JOINT POSITION****************/

void GetJointPosition(int jointNameVar, GLfloat position[3], Skeleton* skelet){

  GLfloat alpha;
  GLfloat beta;
  GLfloat gama;
  alpha = beta = gama = 0;
  //get joint position by name
  if(jointNameVar<3)
  {
    alpha = toRadian(skelet->rshoulderRotUD->rotation);
    beta = toRadian(skelet->rshoulderRotLR->rotation);
    gama = toRadian(skelet->relbowRotUD->rotation);
  }
  else
  {
    alpha = toRadian(skelet->lshoulderRotUD->rotation);
    beta = toRadian(skelet->lshoulderRotLR->rotation);
    gama = toRadian(skelet->lelbowRotUD->rotation);
  }

  switch(jointNameVar){
    case 0:
      position[0] = -1.2;
      position[1] = 6.4;
      position[2] = -0.0;
      break;
    case 1:
      position[0] = -1.2 - 1.5*sin(beta);
      position[1] = 6.4 - 1.5*sin(alpha)*(cos(beta));
      position[2] = -0.0 + 1.5*cos(alpha)*cos(beta);
      break;
    case 2:
      position[0] = -1.2 + (1.5 + 1.5*cos(gama))*sin(beta);
      position[1] = 6.4 - (1.5 + 1.5*cos(gama))*cos(beta)*cos(toRadian(90) - alpha) - 1.5*sin(gama)*sin(toRadian(90) - alpha);
      position[2] = -0.0 + 1.5*cos(alpha)*cos(beta) - 1.5*(sin(gama)*sin(alpha) - cos(gama)*cos(alpha)*cos(beta));
      break;
    case 3:
      position[0] = 1.2;
      position[1] = 6.4;
      position[2] = -0.0;
      break;
    case 4:
      position[0] = 1.2 + 1.5*sin(beta);
      position[1] = 6.4 - 1.5*sin(alpha)*(cos(beta));
      position[2] = -0.0 + 1.5*cos(alpha)*cos(beta);
      break;
    case 5:
      position[0] = 1.2 + (1.5 + 1.5*cos(gama))*sin(beta);
      position[1] = 6.4 - (1.5 + 1.5*cos(gama))*cos(beta)*cos(toRadian(90) - alpha) - 1.5*sin(gama)*sin(toRadian(90) - alpha);
      position[2] = -0.0 + 1.5*cos(alpha)*cos(beta) - 1.5*(sin(gama)*sin(alpha) - cos(gama)*cos(alpha)*cos(beta));
      break;
    default:
      break;
  }
}
/****************************************************/

/*************************CALCULATE MOVE ANGLES***********************************/
GLfloat GetMoveAngleUD(GLfloat begin[3], GLfloat top[3], GLfloat end[3]){

  //calculate move angle for joint
  //A-position of joint to move B-position of top manipulator C-position of finish
  GLfloat k1, k2, k3, alpha;
  k1 = (begin[1]-top[1])/(begin[2]-top[2]);
  k2 = (begin[1]-end[1])/(begin[2]-end[2]);
  k3 = (k2-k1)/(1+k1*k2);
  alpha = atan(k3);
  return (alpha*180/3.141592653);
}

GLfloat GetMoveAngleLR(GLfloat begin[3], GLfloat top[3], GLfloat end[3]){

  //calculate move angle for joint
  //A-position of joint to move B-position of top manipulator C-position of finish
  GLfloat k1, k2, k3, alpha;
  k1 = (begin[0]-top[0])/(begin[2]-top[2]);
  k2 = (begin[0]-end[0])/(begin[2]-end[2]);
  k3 = (k2-k1)/(1+k1*k2);
  alpha = atan(k3);
  return (alpha*180/3.141592653);
}
///*********************************************/

HDC			hDC=NULL;
HGLRC		hRC=NULL;
HWND		hWnd=NULL;
HINSTANCE	hInstance;

bool	keys[256];
bool	active=TRUE;
bool	fullscreen=FALSE;

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

//resize window function
void ReSizeGLScene(GLsizei width, GLsizei height)
{
	if (height==0)
	{
		height=1;
	}

	glViewport(0,0,width,height);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

//initialize function
bool InitGL(void)
{
	glShadeModel(GL_SMOOTH);
	glClearColor(0.8f, 0.8f, 0.8f, 0.5f);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);
	glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	setMoveSkelet();
	return TRUE;
}

//function to draw everything
int DrawGLScene(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	GLUquadricObj *obj = gluNewQuadric();

	glTranslatef(0.0, -4.0, zoom);
	glRotatef(rotX, 1.0f, 0.0f, 0.0f);
	glRotatef(rotY, 0.0f, 1.0f, 0.0f);
	glRotatef(rotZ, 0.0f, 0.0f, 1.0f);
	glColor3f(0.1, 0.5, 0.2);
	glBegin(GL_QUADS);
	glVertex3f(-15.0, 0.0, 20.0);
	glVertex3f(15.0, 0.0, 20.0);
	glVertex3f(15.0, 0.0, -20.0);
	glVertex3f(-15.0, 0.0, -20.0);
	glEnd();

  skelet->DrawSkeleton();

  if(DK){
  timer += moveDuration;
  if(timer/1000 > 5)timer = 0;
  //cout<<"timer: "<<timer<<endl;
  AnimateSkeletDK(timer, skeletDK);
  }


  glPushMatrix();
  glTranslatef(positions[2][0], positions[2][1], positions[2][2]);
  gluSphere(obj, 0.2, 10, 10);
  glPopMatrix();
  glFlush();
	return TRUE;
}

//free all memory and close window
void KillGLWindow(void)
{
	if (fullscreen)
	{
		ChangeDisplaySettings(NULL,0);
		ShowCursor(TRUE);
	}

  DeleteSkeletons();
	wglMakeCurrent(NULL, NULL);
	wglDeleteContext(hRC);
	hRC = NULL;
	ReleaseDC(hWnd, hDC);
	hDC = NULL;
	DestroyWindow(hWnd);
	hWnd = NULL;
	UnregisterClass("OpenGL", hInstance);
	hInstance = NULL;
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/

BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	RegisterClass(&wc);

	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};

	hDC = GetDC(hWnd);
	PixelFormat = ChoosePixelFormat(hDC, &pfd);
	SetPixelFormat(hDC, PixelFormat, &pfd);

	hRC = wglCreateContext(hDC);
	wglMakeCurrent(hDC, hRC);

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	InitGL();

	return TRUE;									// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	// Create Our OpenGL Window
	if (!CreateGLWindow("My kinematic model",640,480,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if (active)								// Program Active?
			{
				if (keys[VK_ESCAPE])				// Was ESC Pressed?
				{
					done=TRUE;						// ESC Signalled A Quit
				}
				else								// Not Time To Quit, Update Screen
				{
					DrawGLScene();					// Draw The Scene
					SwapBuffers(hDC);				// Swap Buffers (Double Buffering)
				}
			}

			if (keys[VK_F1])						// Is F1 Being Pressed?
			{
				keys[VK_F1]=FALSE;					// If So Make Key FALSE
				KillGLWindow();						// Kill Our Current Window
				fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!CreateGLWindow("My kinematic model",640,480,16,fullscreen))
				{
					return 0;						// Quit If Window Was Not Created
				}
			}

			if (keys['W'])
			{
			  rotX += 0.1;
			}
			if (keys['S'])
			{
			  rotX -= 0.1;
			}
			if (keys['A'])
			{
			  rotY += 0.1;
			}
			if (keys['D'])
			{
			  rotY -= 0.1;
			}
			if (keys['Z'])
			{
			  keys['Z'] = FALSE;
			  zoom += 0.5;
			}
      if (keys['U'])
			{
			  keys['U'] = FALSE;
			  zoom -= 0.5;
			}
			if (keys['R'])
			{
			  keys['R'] = FALSE;
			  move += 0.001;
			}
			if (keys['T'])
			{
			  keys['T'] = FALSE;
			  move -= 0.001;
			  if(move < 0.005)move = 0.005;
			}
      if (keys['E'])
      {
        keys['E'] = FALSE;
        if(animateJacobian){
          AnimateSkeletJakobian(skelet);
        }
        else{
          AnimateSkeletCCD(skelet);
        }
      }
      if (keys[VK_UP])
      {
        keys[VK_UP] = FALSE;
        positions[2][1] +=0.5;
      }
      if (keys[VK_DOWN])
      {
        keys[VK_DOWN] = FALSE;
        positions[2][1] -=0.5;
      }
      if (keys['1'])
      {
        keys['1'] = FALSE;
        DK = !DK;
      }
      if (keys['0'])
      {
        keys['0'] = FALSE;
        positions[2][0] *=-1;
      }
      if (keys['2'])
      {
        keys['2'] = FALSE;
        //count = 0;
        animateJacobian = !animateJacobian;
        cout<<"animate with Jacobian: "<<animateJacobian<<endl;
      }
      if (keys[VK_LEFT])
      {
        keys[VK_LEFT] = FALSE;
        positions[2][0] -=0.1;
      }
      if (keys[VK_RIGHT])
      {
        keys[VK_RIGHT] = FALSE;
        positions[2][0] +=0.1;
      }
      if (keys[VK_PRIOR])
      {
        keys[VK_PRIOR] = FALSE;
        positions[2][2] -=0.2;
      }
      if (keys[VK_NEXT])
      {
        keys[VK_NEXT] = FALSE;
        positions[2][2] +=0.2;
      }
		}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}
