#ifdef WIN32
#include <windows.h>
#endif

#include <gl\gl.h>
#include <gl\glu.h>
#include <string>
#include "skeletonElements.h"

using namespace std;

Color::Color(GLfloat red, GLfloat green, GLfloat blue)
{
  this->red = red;
  this->green = green;
  this->blue = blue;
}

SkeletonLink::SkeletonLink(string linkName, GLfloat width, GLfloat length, int shapeType, Color* linkColor)
{
  this->linkName = linkName;
  this->width = width;
  this->length = length;
  this->shape = shapeType;
  this->linkColor = linkColor;
}

void SkeletonLink::doRotation()
{
  for(vector<SkeletonJoints*>::iterator i = joints.begin(); i != joints.end(); i++){

    if((*i)->jointName.find("RotUD") != string::npos)
    {
      glRotatef((*i)->rotation, 1.0, 0.0, 0.0);
    }
    else if((*i)->jointName.find("RotLR") != string::npos)
    {
      glRotatef((*i)->rotation, 0.0, 1.0, 0.0);
    }
  }
}
/*****************************JOINTS******************************/
SkeletonJoints::SkeletonJoints(string jointName, GLfloat rotation, GLfloat min, GLfloat max)
{
  this->jointName = jointName;
  this->rotation = rotation;
  this->min = min;
  this->max = max;
  //this->translation = translation;
}

void SkeletonJoints::SetRotation(GLfloat rotation)
{
  if(rotation > this->max)this->rotation = this->max;
  else if(rotation < this->min)this->rotation = this->min;
  else this->rotation = rotation;
}

GLfloat SkeletonJoints::GetRotation()
{
  return this->rotation;
}
/***********************************************************/
