#ifndef SKELETONELEMENTS_H_INCLUDED
#define SKELETONELEMENTS_H_INCLUDED

#include <gl\gl.h>
#include <gl\glu.h>
#include <string>
#include <iostream>
#include <vector>

using namespace std;

class Color
{
  public:
  Color(GLfloat red, GLfloat green, GLfloat blue);
  GLfloat red;
  GLfloat green;
  GLfloat blue;
};

class SkeletonJoints
{
  public:
  SkeletonJoints(string jointName, GLfloat rotation, GLfloat min, GLfloat max);
  void SetRotation(GLfloat rotation);
  GLfloat GetRotation();
  string jointName;
  GLfloat rotation;
  GLfloat min;
  GLfloat max;
  //GLfloat translation[3];
};

class SkeletonLink
{
  public:
  SkeletonLink(string linkName, GLfloat width, GLfloat length, int shapeType, Color* linkColor);
  void doRotation();
  string linkName;
  Color* linkColor;
  GLfloat length;
  GLfloat width;
  GLint shape;
  vector<SkeletonJoints*> joints;
  SkeletonLink* parentLink;
};

#endif // SKELETONELEMENTS_H_INCLUDED
